//  

#include <stdio.h>
#include <math.h>
#include <iostream.h>

class Vector
{
	double x1, x2;					//  
public:
									//  
	Vector (double c1, double c2)
	{								//  
		x1=c1;		x2=c2;
	}
	Vector ()						// Default
	{ x1 = x2 = 0.; }
	Vector (const Vector& v)		// Copy
	{
		x1 = v.x1;
		x2 = v.x2;
	}
	//======   =====//
	Vector operator=(Vector& v)		// 
	{
		if (this==&v) return *this;
		x1=v.x1;			x2=v.x2;
		return *this;
	}

	bool operator>(Vector& v)		//  >
	{
		return !*this > !v;
	}
	
	bool operator==(Vector& g)		//  
	{
		return x1==g.x1 && x2==g.x2;
	}

	Vector operator+(Vector& g)		// 
	{
		return Vector (x1+g.x1, x2+g.x2);
	}

	Vector operator-(Vector& g)		// 
	{
		return Vector(x1-g.x1, x2-g.x2);
	}

	Vector operator*(double f)		//   
	{
		return Vector(f*x1, f*x2);
	}
	
	double operator*(Vector& g)		//  
	{
		return (x1*g.x1 + x2*g.x2);
	}
	
	double operator!()				//  
	{
		return sqrt (x1*x1+x2*x2);
	}
	
	Vector operator++()				//  ++
	{
		double d=!*this,	dn=(d+1.)/d;
		x1 *= dn;			x2 *= dn;
		return *this;
	}

	Vector operator++(int)			//  ++
	{
		Vector temp=*this;			//   
		double d=!*this,	dn=(d+1.)/d;
		x1 *= dn;			x2 *= dn;		//   
		return temp;						//   - 
	}

	friend Vector operator*(double, Vector&);
	friend ostream& operator<<(ostream&, Vector& v);
	friend istream& operator>>(istream&, Vector& v);
};

		//======  friend- ======//
Vector operator*(double f, Vector& g)
{		// .  
	return Vector(f*g.x1, f*g.x2);
}

ostream& operator<<(ostream& os, Vector& v)
{
	return os<<"\n Vector:  x1="<<v.x1<<" x2="<<v.x2;
}

istream& operator>>(istream& is, Vector& v)
{
	double d1, d2;
	cout << "\n x1= ";		is >> d1;
	cout << " x2= ";		is >> d2;
	v=Vector (d1, d2);		//  
	return is;				//  
}

void main()
{
	Vector a(3,4), b(0,4), c=a, vv[5];
	puts ("\n Class Vector Demonstration");

	c=vv[0]=b;				//  
	printf ("\n Norm of c=vv[0]=b:\t %6.2f",!c);
	
	c=5.*a;					//    
	printf ("\n Norm of 5.*a:\t\t %6.2f",!c);
	
	c=b*!a*5.;				//    
	printf ("\n Norm of c=b*!a*5.:\t %6.2f",!c);
	
	c=a+b;					//  
	printf ("\n Norm of a+b:\t\t %6.2f",!c);
	printf ("\n Norm of a-b:\t\t %6.2f",!(a-b));
	printf ("\n\n Scalar product (a,b) = %3.0f",a*b);
	
	if (b>a)				//   >
		puts("\n\n Norm of b is greater than that of a");
	
	if (a==b) ;				//   ==
	else 
		puts("\n\n Vector a is not equal to vector b");
	
	a=b;
	if (a==b)				//   ==
		puts("\n After assignment a=b; we have  a==b");
	
	vv[3]=a;				//   
	printf ("\n Norm of  vv[3]=a =\t %6.2f",!vv[3]);

	a=++b;					//   ++
	printf ("\n Norm of a=++b:\t\t %6.2f",!a);

	b=a++;					//   ++
	printf ("\n Norm of b=a++:\t\t %6.2f",!b);
	printf ("\n After a++ the norm of a:%6.2f",!a);
	
	Vector x, y;			//   -
	cout << "\n\n Enter vector:";		cin >> x;
	cout << "\n Enter one more:";		cin >> y;
	cout << "\n\n You have entered: " << x <<y;
	cout << "\n The norm of |x+y|="
		 << !(x+y) << "\n\n";

	puts("\n\n");
}
